﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace doubleClickFormula
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.AllowDragFill = true;
            fpSpread1.AllowUserFormulas = true;
            fpSpread1.CellDoubleClick += new FarPoint.Win.Spread.CellClickEventHandler(fpSpread1_CellDoubleClick);
            fpSpread1.DragFillBlock += new FarPoint.Win.Spread.DragFillBlockEventHandler(fpSpread1_DragFillBlock);
        }

        void fpSpread1_DragFillBlock(object sender, FarPoint.Win.Spread.DragFillBlockEventArgs e)
        {
            e.DataOnly = false;
        }

        void fpSpread1_CellDoubleClick(object sender, FarPoint.Win.Spread.CellClickEventArgs e)
        {
            FarPoint.Win.Spread.HitTestInformation hti;
            FarPoint.Win.Spread.ViewportHitTestInformation vi;
            hti = fpSpread1.HitTest(e.X, e.Y);
            vi = hti.ViewportInfo;

            if (hti.Type == FarPoint.Win.Spread.HitTestType.Viewport)
            {
                if (vi.InDragFill == true)
                {
                    if (fpSpread1.ActiveSheet.Cells[e.Row, e.Column].Formula != "")
                    {
                        int lindex = -1, rindex = -1;
                        int r = e.Row;
                        if (e.Column != 0)
                        {
                            while (fpSpread1.ActiveSheet.Cells[r, e.Column - 1].Value != null)
                            {
                                lindex = r;
                                r++;
                            }
                            if (lindex == -1)
                            {
                                while (fpSpread1.ActiveSheet.Cells[r, e.Column + 1].Value != null)
                                {
                                    rindex = r;
                                    r++;
                                }
                            }
                        }
                        else
                        {
                            while (fpSpread1.ActiveSheet.Cells[r, e.Column + 1].Value != null)
                            {
                                rindex = r;
                                r++;
                            }
                        }
                        if (lindex != -1)
                        {
                            for (int r1 = e.Row + 1; r1 <= lindex; r1++)
                            {
                                string form = fpSpread1.ActiveSheet.Cells[r1 - 1, e.Column].Formula;
                                char[] arr = form.ToCharArray();
                                string newformula = "";
                                for (int index = 0; index < arr.Length; index++)
                                {
                                    char temp = arr[index];
                                    int atemp = (int)temp;
                                    string s = "";
                                    if (atemp >= 48 && atemp <= 57)
                                    {
                                        int sindex;
                                        if (index != 0)
                                        {
                                            int btemp = arr[index - 1];
                                            if ((btemp >= 65 && btemp <= 90) || (btemp >= 97 && btemp <= 122))
                                            {
                                                for (sindex = index; sindex < arr.Length; sindex++)
                                                {
                                                    if ((int)arr[sindex] >= 48 && (int)arr[sindex] <= 57)
                                                    {
                                                        s = s + arr[sindex].ToString();
                                                    }
                                                    else
                                                    {
                                                        break;
                                                    }
                                                }
                                                index = sindex - 1;
                                                int sint = Convert.ToInt32(s);
                                                sint = sint + 1;
                                                s = sint.ToString();
                                                newformula = newformula + s;
                                            }
                                            else
                                            {
                                                newformula = newformula + arr[index];
                                            }
                                        }
                                    }
                                    else
                                    {
                                        newformula = newformula + arr[index];
                                    }
                                }
                                fpSpread1.ActiveSheet.Cells[r1, e.Column].Formula = newformula;
                            }
                        }
                        else
                        {
                            if (rindex != -1)
                            {
                                for (int r1 = e.Row + 1; r1 <= rindex; r1++)
                                {
                                    string form = fpSpread1.ActiveSheet.Cells[r1 - 1, e.Column].Formula;
                                    char[] arr = form.ToCharArray();
                                    string newformula = "";
                                    for (int index = 0; index < arr.Length; index++)
                                    {
                                        char temp = arr[index];
                                        int atemp = (int)temp;
                                        string s = "";
                                        if (atemp >= 48 && atemp <= 57)
                                        {
                                            int sindex;
                                            if (index != 0)
                                            {
                                                int btemp = arr[index - 1];
                                                if ((btemp >= 65 && btemp <= 90) || (btemp >= 97 && btemp <= 122))
                                                {
                                                    for (sindex = index; sindex < arr.Length; sindex++)
                                                    {
                                                        if ((int)arr[sindex] >= 48 && (int)arr[sindex] <= 57)
                                                        {
                                                            s = s + arr[sindex].ToString();
                                                        }
                                                        else
                                                        {
                                                            break;
                                                        }
                                                    }
                                                    index = sindex - 1;
                                                    int sint = Convert.ToInt32(s);
                                                    sint = sint + 1;
                                                    s = sint.ToString();
                                                    newformula = newformula + s;
                                                }
                                                else
                                                {
                                                    newformula = newformula + arr[index];
                                                }
                                            }
                                        }
                                        else
                                        {
                                            newformula = newformula + arr[index];
                                        }
                                    }
                                    fpSpread1.ActiveSheet.Cells[r1, e.Column].Formula = newformula;
                                }
                            }

                        }
                    }
                }
            }
        }
    }
}
                                         
        

